package utility;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.Arrays;

import org.json.JSONException;
import org.json.JSONObject;

import scenari.Automa;

public class Esecutore extends Thread {

//	private MyQueue<Integer> codaVal; // coda in cui vengono mantenuti i valori da sommare alla variabile valore
//	private int valore; // variabile numerica cumulativa inizialmente impostata a 0
//	public final int SOGLIA = 100;
	private Publisher publisher;
	private Automa automa;
//	private String outputSuono; // nome logico dell'interruttore che fa scattare il suono dell'allarme 

	public Esecutore( Publisher publisher, /*MyQueue<Integer> codaVal, */ Automa automa) {
//		this.codaVal = codaVal;
//		this.valore = 0;
		this.automa = automa;
		this.publisher = publisher;
//		this.outputSuono = outputSuono;
	}
	
//	private int numeroRighe = 0;

	public void run() {
//		qui ci va la business logic
		try {
			while (true) {
				LocalTime ora = LocalTime.now();
//				if(!automa.waitForAntifurto())
				if(!automa.getAntifurto())
					continue;
				// l’antifurto è acceso
				FileReader fr = randomFileScenari();
				if(fr == null )//|| numeroRighe == 0)
					continue;
				BufferedReader br = new BufferedReader(fr);// selezioniamo un file contenente i comandi
				String line = br.readLine();//su ogni linea si trova un nuovo comando, in ordine di tempo dal meno recente al piu' recente
//				numeroRighe--;
				while(line.isBlank()) {
					line = br.readLine();
//					numeroRighe--;
				}
				LocalTime tempoCmd = LocalTime.now();
				boolean startedPublishing = false;
//				String nomeLuce;
//				String cmd;
				while(line != null && ora.isBefore(tempoCmd)/*&& numeroRighe > 0*//*&& tempoCmd.isBefore(LocalTime.now())*/) {
					ora = LocalTime.now();
//					System.out.println("\tsecondo ciclo");
					
					JSONObject jline = new JSONObject(line);
					String[] time = jline.getString("tempo").split("-");
//					System.out.println("using: "+line+" + "+time.length);
					if(time.length != 3) {
//						System.out.println(jline.getString("tempo"));
						continue;
					}
					tempoCmd = LocalTime.of(Integer.valueOf(time[0]), Integer.valueOf(time[1]), Integer.valueOf(time[2]));// otteniamo [la data e] l’ora in cui è stato inviato quel comando

					LocalTime tempoAttuale = LocalTime.now();
					try {
						long waitingTime = Helper.timeDifference(tempoAttuale, tempoCmd)*1000;
						if(waitingTime > 1000) {
//							System.out.println(tempoAttuale);
//							System.out.println(tempoCmd);
//							System.out.println("Waiting to execute command");
//							long offset = ((Double) (Math.random() * 10)).intValue()*1000;//trova un valore tra 1 e 10 (*1000)
							//ThreadLocalRandom.current().nextLong(10000);
//							if(offset%2 == 0) {
//								waitingTime += offset;// + 1000;
//							} else waitingTime -= offset;
//							waitingTime += 1000;
//							System.out.println(waitingTime);
//							if(waitingTime > 1000)
								Thread.sleep(waitingTime);
							
//							System.out.println("running...");
							startedPublishing = true;
						} //else System.out.println("useless");
						if(startedPublishing) {
//							System.out.println("\tpublishing");
							String nomeLuce = jline.getString("luce");
							String cmd = jline.getString("cmd");
//							System.out.println("to/gruppo2/luci/gpio/"+nomeLuce);
//							System.out.println("{cmd:"+cmd+"}");
							publisher.aggiungiComando("to/gruppo2/luci/gpio/"+nomeLuce, "{cmd:"+cmd+"}");
						}
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
					line = br.readLine();
//					numeroRighe--;
					if(line != null)
						while(line.isBlank()) {
							line = br.readLine();
	//						numeroRighe--;
						}
//					System.out.println("should restart? "+line != null+" ; "+ora.isBefore(tempoCmd));
//					System.out.println(line != null && ora.isBefore(tempoCmd));
				}
//				now line == null so I'm done reading the file
//				TODO something about this
				br.close();
				fr.close();
//				numeroRighe = 0;
			}
		} catch (IOException | JSONException e) {
			e.printStackTrace();
		}
	}

	private synchronized FileReader randomFileScenari() throws IOException {
		// Creating a File object for directory
		File directoryPath = new File("./db-scenari/");
		// List of all files and directories
		final ArrayList<File> filesListRaw = new ArrayList<File>(Arrays.asList(directoryPath.listFiles()));
		final ArrayList<File> filesList = new ArrayList<File>();
		for(File f : filesListRaw) {
			if(f.toString().endsWith(".json"))
				filesList.add(f);
		}
		int maxFiles = filesList.size();
		if(maxFiles == 0)
			return null;
		if(maxFiles == 1) {
			File f = filesList.get(0);
//			numeroRighe = ((Long)(Files.lines(f.toPath()).count())).intValue();
			return new FileReader(f);
		}
		File path = null;
		do {
			path = filesList.get(((Double) (Math.random() * maxFiles)).intValue());
		} while(path == null);
		return new FileReader(path);
	}

}
