package utility;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.eclipse.paho.client.mqttv3.MqttTopic;

import scenari.Scenari;

public class Publisher extends Thread {

	private MyQueue<Pair> coda;
	private Scenari scenari;
	
	public Publisher(MyQueue<Pair> coda, Scenari scenari) {
		this.coda = coda;
		this.scenari = scenari;
	}
	
	public void aggiungiComando(String topic, String msg) {
		coda.send(new Pair(topic, msg));
	}
	
	
	public void run() {
		while(true) {
			Pair p = coda.receive();
			try {
				sendMqttMessage(p.getTopic(), p.getMsg());
			} catch (MqttException e) {
				e.printStackTrace();
			}
		}
	}
	
	private void sendMqttMessage(String topic, String msg) throws MqttException {
		final MqttTopic msgTopic = scenari.mqttClient.getTopic(topic);
		msgTopic.publish(new MqttMessage(msg.getBytes()));
	}
}
